' Created		2006-12-05
' Modified		2006-12-05
' Project		
' Model			
' Company		
' Author			
' Version		
' Database		Access 2000 

'=======================================================
'=== MS Access 2000 database creation method
'===
'=== 1. Create a new database in the MS Access 2000
'=== 2. Create a new module
'=== 3. Copy the CASE Studio 2 output SQL script into the new MS Access 2000 module
'=== 4. Select from main menu "Tools" item "References..." and check the "Microsoft DAO 3.6 Object Library."
'=== 5. Place your mouse cursor somewhere in the main procedure Main()
'=== 6. Run the module code (Click the "Run Sub/UserForm" button or press F5)
'=======================================================

Public dbs As DAO.Database
Public tdf As DAO.TableDef
Public idx As DAO.Index
Public rel As DAO.Relation

Sub Main()

Set dbs = CurrentDb()

On Error GoTo ErrorHandler
	
	
	
	
	Call CreateTables
	Call CreatePrimaryKeys
	Call CreateIndexes
	
	
	
	
	
	MsgBox "Script successfully processed.", vbInformation
	Exit Sub
	
ErrorHandler:
	Select Case Err.Number
		Case 3010
			MsgBox "Table " & tdf.Name & " allready exist!", vbInformation
			Err.Clear
      Case 3284
         MsgBox "Index " & idx.Name & " for table " & tdf.Name & " allready exist!", vbInformation
         Err.Clear
		Case Else
			MsgBox Err.Description, vbCritical
	End Select
End Sub


' Create tables
'===============

Sub CreateTables()

Call CreateTable1 'Pracownicy
Call CreateTable2 'Adres
Call CreateTable3 'Oddziay
End Sub

'=== Create table Pracownicy ======

Sub CreateTable1()

Set tdf = dbs.CreateTableDef( "Pracownicy" )

Call AddFieldToTable("PESEL", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("Imie", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("Nazwisko", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("Numer", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("Przelozony", dbText, 50, 0, "", "", "", TRUE, FALSE )

dbs.TableDefs.Append tdf



End Sub

'=== Create table Adres ======

Sub CreateTable2()

Set tdf = dbs.CreateTableDef( "Adres" )

Call AddFieldToTable("Miasto", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("Ulica", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("Numery", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("PESEL", dbText, 50, 0, "", "", "", TRUE, FALSE )

dbs.TableDefs.Append tdf



End Sub

'=== Create table Oddziay ======

Sub CreateTable3()

Set tdf = dbs.CreateTableDef( "Oddziay" )

Call AddFieldToTable("Numer", dbText, 50, 0, "", "", "", TRUE, FALSE )
Call AddFieldToTable("Nazwa", dbText, 50, 0, "", "", "", TRUE, FALSE )

dbs.TableDefs.Append tdf



End Sub



' Create primary keys
'=====================

Sub CreatePrimaryKeys()

'=== Create primary key for table Pracownicy ======

Set tdf = dbs.TableDefs( "Pracownicy" )
Set idx = tdf.CreateIndex( "PESEL" )

idx.Primary = True
idx.Unique  = True
idx.IgnoreNulls = False

Call AddFieldToIndex( "PESEL", False )

tdf.Indexes.Append idx

'=== Create primary key for table Adres ======

Set tdf = dbs.TableDefs( "Adres" )
Set idx = tdf.CreateIndex( "pk_Adres" )

idx.Primary = True
idx.Unique  = True
idx.IgnoreNulls = False

Call AddFieldToIndex( "PESEL", False )

tdf.Indexes.Append idx

'=== Create primary key for table Oddziay ======

Set tdf = dbs.TableDefs( "Oddziay" )
Set idx = tdf.CreateIndex( "pk_Oddziay" )

idx.Primary = True
idx.Unique  = True
idx.IgnoreNulls = False

Call AddFieldToIndex( "Numer", False )

tdf.Indexes.Append idx


End Sub


' Create indexes
'================

Sub CreateIndexes()


End Sub

' Add fields to table
'=====================

Sub AddFieldToTable(FieldName As String, DataType As String, SizeCol As Integer, Attributes As Long, DefaultValue As Variant, ValText As String, ValRule As String, NotN As Boolean, ZeroLength As Boolean)

Dim fld As DAO.Field

Set fld = tdf.CreateField( FieldName, DataType )

If SizeCol 		<> 0 Then fld.Size	   	= SizeCol
If Attributes	<> 0 Then fld.Attributes	= Attributes

fld.Required 			= NotN
If DataType = dbText or DataType = dbMemo Then fld.AllowZeroLength = ZeroLength
fld.DefaultValue 		= DefaultValue
fld.ValidationRule 	= ValRule
fld.ValidationText 	= ValText

tdf.Fields.Append fld

End Sub

' Add properties to table
'=========================

Sub AddPropertyToTable( PropertyName As String, Value As Variant, DataType As String)

Dim prp As DAO.Property

Set prp = tdf.CreateProperty(PropertyName, DataType, Value)

tdf.Properties.Append prp

End Sub


' Add properties to field
'=========================

Sub AddPropertyToField( FieldName As String, PropertyName As String, Value As Variant, DataType As String)

Dim prp As DAO.Property
Dim fld As DAO.Field

Set fld = tdf.Fields( FieldName )
Set prp = fld.CreateProperty(PropertyName, DataType, Value)

fld.Properties.Append prp

End Sub


' Add fields to index
'=====================

Sub AddFieldToIndex( FieldName As String, Descending As Boolean )

Dim fld As DAO.Field

Set fld = idx.CreateField( FieldName )

If Descending = True Then fld.Attributes = dbDescending

idx.Fields.Append fld

End Sub




